<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"
    />

    <title>ROOT tutorial</title>

    <link rel="stylesheet" href="dist/reset.css" />
    <link rel="stylesheet" href="dist/reveal.css" />
    <link rel="stylesheet" href="dist/theme/black.css" id="theme" />

    <!-- Theme used for syntax highlighted code -->
    <link
      rel="stylesheet"
      href="plugin/highlight/monokai.css"
      id="highlight-theme"
    />
  </head>

  <body>
    <div class="reveal">
      <div class="slides">
        <section
          style="font-family: 'Montserrat', sans-serif; color: black"
          data-background-color="white"
        >
          <div style="font-weight: 500; font-size: 80px">ROOT tutorial</div>
          <div
            style="
              font-weight: 300;
              font-size: 40px;
              margin-top: 30px;
              margin-bottom: 30px;
            "
          >
            Рабочее совещание «Распределенные вычисления и наука о данных»
          </div>
          <div style="margin-top: 20px">Martin Vala</div>
          <div style="font-size: 20px; margin-top: 10px">
            Pavol Jozef Šafárik University in Košice
          </div>
          <div style="margin-top: 50px">
            <img
              style="width: 150px; height: 150px"
              src="images/jinr_logo.png"
            />
            <img style="width: 150px; height: 150px" src="images/pf_upjs.png" />
            <img style="width: 150px; height: 150px" src="images/tuke.jpg" />
            <img style="width: 150px; height: 150px" src="images/saske.png" />
          </div>
        </section>
        <section data-markdown>
          <script type="text/template">
            ## ROOT usefull links
            - [ROOT webpage](https://root.cern.ch)
            - Documentation
            - [User's guide](https://root.cern/primer/)
            - [Official ROOT tutorial](https://github.com/root-project/training/tree/master/BasicCourse)
            - [This ROOT tutorial](https://ndmspc.gitlab.io/edu/tutorials/20210402-root-tutorial)
            - [Full source code for this tutorial](https://gitlab.com/ndmspc/edu/tutorials/20210402-root-tutorial)
          </script>
        </section>
        <section data-markdown>
          <script type="text/template">
            ## Tutorial links
            - [Tutorial project](https://gitlab-hlit.jinr.ru/hybrilit/tutorials/mse)
            - Tutorial machines
              - [https://rootui01.jinr.ru](https://rootui01.jinr.ru)
              - [https://rootui02.jinr.ru](https://rootui02.jinr.ru)
              - [https://rootui03.jinr.ru](https://rootui03.jinr.ru)
              
          </script>
        </section>

        <section
          data-background-image="images/screen_01.png"
          data-background-size="90%"
        ></section>
        <section
          data-background-image="images/screen_02.png"
          data-background-size="90%"
        ></section>
        <section
          data-background-image="images/screen_03.png"
          data-background-size="90%"
        ></section>
        <section
          data-background-image="images/screen_04.png"
          data-background-size="90%"
        ></section>

        <section data-markdown>
          <script type="text/template">
            ## VS code and some plugins
            - https://code.visualstudio.com/download
            - Extensions
              - SSH Remote
              - C/C++
              - CMakeTools
          </script>
        </section>

        <section>
          <h2>Running root</h2>
          default
          <pre><code class="r-frame" style="font-size: 0.8em;" data-trim data-noescape>
$ root
 ------------------------------------------------------------------
| Welcome to ROOT 6.22/06                        https://root.cern |
| (c) 1995-2020, The ROOT Team; conception: R. Brun, F. Rademakers |
| Built for linuxx8664gcc on Nov 27 2020, 15:14:08                 |
| From tags/v6-22-06@v6-22-06                                      |
| Try '.help', '.demo', '.license', '.credits', '.quit'/'.q'       |
 ------------------------------------------------------------------

root [0] 
      </code></pre>
          Using different options
          <pre><code class="r-frame" style="font-size: 0.8em;" data-trim data-noescape>
$ root -b -l
root [0]
$
        </code></pre>
        </section>

        <section data-markdown>
          <script type="text/template">
            ## ROOT options
            - 'b' : batch mode (no graphics is loaded)
            - 'l' : no splash screen <!-- .element: class="fragment" data-fragment-index="1" -->
            - 'q' : quit after execution is done <!-- .element: class="fragment" data-fragment-index="2" -->
          </script>
        </section>

        <section>
          <h2>Running root [2]</h2>
          No graphis and no splash screen
          <pre><code class="r-frame" style="font-size: 0.8em;" data-trim data-noescape>
$ root -b -l
root [0] .q
$
      </code></pre>
          Or exit automatically
          <pre><code class="r-frame" style="font-size: 0.8em;" data-trim data-noescape>
$ root -l -b -q
$
        </code></pre>
        </section>
        <section data-markdown>
          <textarea data-template>
            Use root as c++ interpreter
            ```cpp [1-2|3|4-6|7-8|9-10]
            root [0] int i = 0
            (int) 1
            root [1] i = 1;
            root [2] printf("Number is %d\n",i)
            Number is 1
            (int) 12
            root [3] printf("Number is %d\n",i);
            Number is 1
            root [4] Printf("Number is %d",++i);
            Number is 2
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Run these commands from file (macro).
            
            ```cpp []
            $ cat m1.C
            {
              int i = 0;
              i = 1;
              printf("Number is %d\n",i);
              Printf("Number is %d",++i);
            }
            ```
            Execute by root
            ```bash
            $ root -l m1.C 

            Processing m1.C...
            Number is 1
            Number is 2
            root [1] .q
            ```
            Note that ';' is needed in macro
          </textarea>
        </section>
        <section data-markdown>
          <textarea data-template>
            What exactly happen?
            ```cpp []
            $ root -l
            root [0] .x m1.C 
            Number is 1
            Number is 2
            root [1] .q
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Let's reuse macro several time
            ```cpp
            $ cat m2.C
            void m2(int a=1, int b=2) {
              int sum = a+b;
              Printf("Sum of %d and %d is %d.",a,b,sum);
            }
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Let's execute it
            ```cpp [1-2|3-4|5-6|7-8|9-10]
            root [0] .x m2.C 
            Sum of 1 and 2 is 3.
            root [1] m2(
            void m2(int a = 1, int b = 2)
            root [1] m2(4,5)
            Sum of 4 and 5 is 9.
            root [2] m2(4)
            Sum of 4 and 2 is 6.
            root [3] m2(,5)
            ROOT_prompt_3:1:4: error: expected expression
            m2(,5)
            root [4] .q
               ^            
            ```
            ```cpp []
            $ root -l
            root [0] .L m2.C 
            root [1] m2(4,5)
            Sum of 4 and 5 is 9.
            root [3] .q
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Let's try to compile macro
            ```cpp
            $ cat m3.C | grep -v include
            void m3(int a = 1, int b = 2) {
              int sum = a + b;
              Printf("Sum of %d and %d is %d.", a, b, sum);
            }
            ```
            Let's try to compile macro
            ```cpp []
            $ root -l m3.C+
            Processing m3.C+...
            ...
            ...
            In file included from input_line_12:6:
            ././m3.C:5:5: error: use of undeclared identifier 'Printf'
                Printf("Sum of %d and %d is %d.", a, b, sum);

            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Fix compilation error
            ```cpp
            $ cat m3.C
            #include <TString.h>
            void m3(int a = 1, int b = 2) {
              int sum = a + b;
              Printf("Sum of %d and %d is %d.", a, b, sum);
            }
            ```
            and run it
            ```cpp
            06:44 $ root -l m3.C+
            root [0] 
            Processing m3.C+...
            Info in <TUnixSystem::ACLiC>: creating shared library ...
            ...
            Sum of 1 and 2 is 3.
            root [1] .q
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Let's execute it more times with different arguments

            ```cpp []
            $ root -l
            root [0] .L m3.C+
            ...
            ...
            root [1] m3(4,5)
            Sum of 4 and 5 is 9.
            root [2] m3(9,3)
            Sum of 9 and 3 is 12.
            root [3] .q
            
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            ```cpp [3,14|4,5,12,13|6-7|8-10|11|1-2|3]
            #include <TString.h>
            #include <TStopwatch.h>
            void m4(Long64_t n = 1e5, Long64_t m = 5*1e4) {
              TStopwatch t;
              t.Start();
              Double_t result = 0;
              Long64_t i, j;
              for (i = 0; i < n; i++)
                for (j = 0; j < m; j++)
                    result += i * j;
              Printf("result is %0.0f", result);
              t.Stop();
              t.Print();
            }              
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Test difference between macro and ...
            ```cpp
            06:46 $ root -l
            root [0] .L m4.C
            root [1] m4()
            result is 6249812501246255104
            Real time 0:00:13, CP time 13.270
            root [2] .q
            ```
            compiled macro
            ```
            06:54 $ root -l
            root [0] .L m4.C+
            Info in <TUnixSystem::ACLiC>: creating shared library ...
            ...
            root [1] m4()
            result is 6249812501246255104
            Real time 0:00:03, CP time 3.670
            root [2] .q
            
            ```
          </textarea>
        </section>

        <section data-markdown>
          <textarea data-template>
            Let's do some work ...
          </textarea>
        </section>

        <section
          data-background-image="images/PbPb_blueOnGray.png"
          data-background-size="50%"
        ></section>

        <section data-markdown>
          <textarea data-template>
            Track and event
            ```cpp
            MSE::Event *ev0 = new MSE::Event(0);
            MSE::Track *t0_0 = ev0->AddTrack();
            MSE::Track *t0_1 = ev0->AddTrack();
            MSE::Track *t0_2 = ev0->AddTrack();

            MSE::Event *ev1 = new MSE::Event(1);
            MSE::Track *t1_0 = ev1->AddTrack();
            MSE::Track *t1_1 = ev1->AddTrack();
            MSE::Track *t1_2 = ev1->AddTrack();
            MSE::Track *t1_3 = ev1->AddTrack();
            
            ```
          </textarea>
        </section>

        <section data-markdown>
          <script type="text/template">
            Let's code now
          </script>
        </section>
        
        <section data-markdown>
          <script type="text/template">
            ## One can checkout/join our ndmspc group
            - https://gitlab.com/ndmspc
            - [ndmvr](https://ndmspc.gitlab.io/ndmvr/)
            - [Give us feedback](https://docs.google.com/forms/d/e/1FAIpQLSdg-F8FtP_lyx1TC-rstEqqC2puscEIowRhGnJN9JZDThohXg/viewform)
          </script>
        </section>

      </div>
    </div>    

    <script src="dist/reveal.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/highlight/highlight.js"></script>
    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,
        slideNumber: "c/t",

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [RevealMarkdown, RevealHighlight, RevealNotes],
      });
    </script>
  </body>
</html>
